<h1 class="no-toc">What is Angular?</h1>
<h1 class="no-toc">什么是 Angular？</h1>

Angular is a platform that makes it easy to build applications with the web. Angular combines declarative templates, dependency injection, end to end tooling, and integrated best practices to solve development challenges. Angular empowers developers to build applications that live on the web, mobile, or the desktop

Angular 是一个开发平台。它能帮你更轻松的构建 Web 应用。Angular 集声明式模板、依赖注入、端到端工具和一些最佳实践于一身，为你解决开发方面的各种挑战。Angular 为开发者提升构建 Web、手机或桌面应用的能力。

<div class="card-container">
  <a href="generated/live-examples/quickstart/eplnkr.html" target="_blank" class="docs-card"
    title="通过线上编程环境体验 Angular">
      <section>Angular 走马观花</section>
      <p>快速体验 Angular 的 "hello world" 应用。</p>
      <p class="card-footer">体验 Angular</p>
  </a>

  <div class="docs-card">
      <section>开始使用 Angular</section>
      <p>跟随 "快速上手" 构建你自己的开发环境。</p>
      <p class="card-footer" >
        <a href="guide/quickstart" title="Angular 快速上手">快速上手</a>
      </p>
  </div>

  <a href="guide/architecture" class="docs-card" title="Angular 架构">
      <section>基本原理</section>
      <p>学习 Angular 应用的基本原理。<br/>从架构概览开始。</p>
      <p class="card-footer">架构</p>
  </a>
</div>

## Assumptions

## 基本假设

This documentation assumes that you are already familiar with
[JavaScript](https://developer.mozilla.org/en-US/docs/Web/JavaScript/A_re-introduction_to_JavaScript "Learn JavaScript"),
and some of the tools from the
[latest standards](https://babeljs.io/learn-es2015/ "Latest JavaScript standards") such as
[classes](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Classes "ES2015 Classes")
and [modules](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/import "ES2015 Modules").
The code samples are written using [TypeScript](https://www.typescriptlang.org/ "TypeScript").
Most Angular code can be written with just the latest JavaScript,
using [types](https://www.typescriptlang.org/docs/handbook/classes.html "TypeScript Types") for dependency injection,
and using [decorators](https://www.typescriptlang.org/docs/handbook/decorators.html "Decorators") for metadata.

本文档假设你已经熟悉了[JavaScript](https://developer.mozilla.org/en-US/docs/Web/JavaScript/A_re-introduction_to_JavaScript "学习 JavaScript")和来自[最新标准](https://babeljs.io/learn-es2015/ "Latest JavaScript standards")的一些知识，比如 [类](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Classes "ES2015 类") 和 [模块](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/import "ES2015 模块")。
下列代码范例都是用最新版本的JavaScript写的，利用[类型](https://www.typescriptlang.org/docs/handbook/classes.html "TypeScript 类型")实现依赖注入，并使用[装饰器](https://www.typescriptlang.org/docs/handbook/decorators.html "装饰器")来提供元数据。

## Feedback

## 反馈

You can sit with us!

你也可以和我们一起做贡献！

You can file documentation
[issues](https://github.com/angular/angular/issues "Angular Github issues") and create
[pull requests](https://github.com/angular/angular/pulls "Angular Github pull requests")
on the Angular Github repository.
The [contributing guide](https://github.com/angular/angular/blob/master/CONTRIBUTING.md "Contributing guide")
will help you contribute to the community.
Our community values  respectful, supportive communication.
Please consult and adhere to the
[code of conduct](https://github.com/angular/code-of-conduct/blob/master/CODE_OF_CONDUCT.md "contributor code of conduct").

你可以到 Angular 在 Github 上的仓库中提出文档方面的[问题](https://github.com/angular/angular/issues "Angular Github issues")，并创建[Pull Requests](https://github.com/angular/angular/pulls "Angular Github pull requests")。
[贡献者指南](https://github.com/angular/angular/blob/master/CONTRIBUTING.md "贡献者指南")将会帮助你更好的为社区做贡献。
我们社区的价值观是互相尊重、互相支持。参见[社区行为规范](https://github.com/angular/code-of-conduct/blob/master/CODE_OF_CONDUCT.md "contributor code of conduct")。